KConfigDialog Class Reference

`#include <kconfigdialog.h>`

Inheritance diagram for KConfigDialog:

## Signals

void | widgetModified ()
void | settingsChanged ()
void | settingsChanged (const char *dialogName)
Signals inherited from KDialogBase
void | helpClicked ()
void | defaultClicked ()
void | user3Clicked ()
void | user2Clicked ()
void | user1Clicked ()
void | applyClicked ()
void | tryClicked ()
void | okClicked ()
void | yesClicked ()
void | noClicked ()
void | cancelClicked ()
void | closeClicked ()
void | apply ()
void | backgroundChanged ()
void | hidden ()
void | finished ()
void | aboutToShowDetails ()
void | aboutToShowPage (QWidget *page)
Signals inherited from KDialog
void | layoutHintChanged ()

## Public Member Functions

| KConfigDialog (QWidget *parent, const char *name, KConfigSkeleton *config, DialogType dialogType=IconList, int dialogButtons=Default|Ok|Apply|Cancel|Help, ButtonCode defaultButton=Ok, bool modal=false)
| ~KConfigDialog ()
void | addPage (QWidget *page, const QString &itemName, const QString &pixmapName, const QString &header=QString::null, bool manage=true)
void | addPage (QWidget *page, KConfigSkeleton *config, const QString &itemName, const QString &pixmapName, const QString &header=QString::null)
virtual void | show ()
Public Member Functions inherited from KDialogBase
| KDialogBase (QWidget *parent=0, const char *name=0, bool modal=true, const QString &caption=QString::null, int buttonMask=Ok|Apply|Cancel, ButtonCode defaultButton=Ok, bool separator=false, const KGuiItem &user1=KGuiItem(), const KGuiItem &user2=KGuiItem(), const KGuiItem &user3=KGuiItem())
| KDialogBase (int dialogFace, const QString &caption, int buttonMask, ButtonCode defaultButton, QWidget *parent=0, const char *name=0, bool modal=true, bool separator=false, const KGuiItem &user1=KGuiItem(), const KGuiItem &user2=KGuiItem(), const KGuiItem &user3=KGuiItem())
| KDialogBase (KDialogBase::DialogType dialogFace, WFlags f, QWidget *parent=0, const char *name=0, bool modal=true, const QString &caption=QString::null, int buttonMask=Ok|Apply|Cancel, ButtonCode defaultButton=Ok, bool separator=false, const KGuiItem &user1=KGuiItem(), const KGuiItem &user2=KGuiItem(), const KGuiItem &user3=KGuiItem())
| KDialogBase (const QString &caption, int buttonMask=Yes|No|Cancel, ButtonCode defaultButton=Yes, ButtonCode escapeButton=Cancel, QWidget *parent=0, const char *name=0, bool modal=true, bool separator=false, const KGuiItem &yes=KStdGuiItem::yes(), const KGuiItem &no=KStdGuiItem::no(), const KGuiItem &cancel=KStdGuiItem::cancel())
| ~KDialogBase ()
void | setButtonBoxOrientation (int orientation)
void | setEscapeButton (ButtonCode id)
virtual void | adjustSize ()
virtual QSize | sizeHint () const
virtual QSize | minimumSizeHint () const
QFrame * | plainPage ()
QFrame * | addPage (const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QFrame * | addPage (const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QVBox * | addVBoxPage (const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QVBox * | addVBoxPage (const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QHBox * | addHBoxPage (const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QHBox * | addHBoxPage (const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QGrid * | addGridPage (int n, Orientation dir, const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QGrid * | addGridPage (int n, Orientation dir, const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
void | setFolderIcon (const QStringList &path, const QPixmap &pixmap)
QFrame * | makeMainWidget ()
QVBox * | makeVBoxMainWidget ()
QHBox * | makeHBoxMainWidget ()
QGrid * | makeGridMainWidget (int n, Orientation dir)
void | enableButtonSeparator (bool state)
void | showButton (ButtonCode id, bool state)
void | showButtonOK (bool state)
void | showButtonApply (bool state)
void | showButtonCancel (bool state)
bool | showPage (int index)
int | activePageIndex () const
int | pageIndex (QWidget *widget) const
void | setMainWidget (QWidget *widget)
QWidget * | mainWidget ()
void | disableResize ()
void | setInitialSize (const QSize &s, bool noResize=false)
void | incInitialSize (const QSize &s, bool noResize=false)
QSize | configDialogSize (const QString &groupName) const
QSize | configDialogSize (KConfig &config, const QString &groupName) const
void | saveDialogSize (const QString &groupName, bool global=false)
void | saveDialogSize (KConfig &config, const QString &groupName, bool global=false) const
void | setButtonOK (const KGuiItem &item=KStdGuiItem::ok())
void | setButtonOKText (const QString &text=QString::null, const QString &tooltip=QString::null, const QString &quickhelp=QString::null) KDE_DEPRECATED
void | setButtonApply (const KGuiItem &item=KStdGuiItem::apply())
void | setButtonApplyText (const QString &text=QString::null, const QString &tooltip=QString::null, const QString &quickhelp=QString::null) KDE_DEPRECATED
void | setButtonCancel (const KGuiItem &item=KStdGuiItem::cancel())
void | setButtonCancelText (const QString &text=QString::null, const QString &tooltip=QString::null, const QString &quickhelp=QString::null) KDE_DEPRECATED
void | setButtonText (ButtonCode id, const QString &text)
void | setButtonTip (ButtonCode id, const QString &text)
void | setButtonWhatsThis (ButtonCode id, const QString &text)
void | setButtonGuiItem (ButtonCode id, const KGuiItem &item)
void | setTreeListAutoResize (bool state)
void | setShowIconsInTreeList (bool state)
void | setRootIsDecorated (bool state)
void | unfoldTreeList (bool persist=false)
void | addWidgetBelowList (QWidget *widget)
void | addButtonBelowList (const QString &text, QObject *recv, const char *slot)
void | addButtonBelowList (const KGuiItem &guiitem, QObject *recv, const char *slot)
void | setIconListAllVisible (bool state)
void | showTile (bool state)
void | getBorderWidths (int &ulx, int &uly, int &lrx, int &lry) const KDE_DEPRECATED
QRect | getContentsRect () const KDE_DEPRECATED
QSize | calculateSize (int w, int h) const
QString | helpLinkText () const
QPushButton * | actionButton (ButtonCode id)
Public Member Functions inherited from KDialog
| KDialog (QWidget *parent=0, const char *name=0, bool modal=false, WFlags f=0)

## Static Public Member Functions

static KConfigDialog * | exists (const char *name)
static bool | showDialog (const char *name)
Static Public Member Functions inherited from KDialogBase
static bool | haveBackgroundTile ()
static const QPixmap * | backgroundTile ()
static const QPixmap * | getBackgroundTile () KDE_DEPRECATED
static void | setBackgroundTile (const QPixmap *pix)
Static Public Member Functions inherited from KDialog
static int | marginHint ()
static int | spacingHint ()
static void | resizeLayout (QWidget *widget, int margin, int spacing)
static void | resizeLayout (QLayoutItem *lay, int margin, int spacing)
static void | centerOnScreen (QWidget *widget, int screen=-1)
static bool | avoidArea (QWidget *widget, const QRect &area, int screen=-1)

## Protected Slots

virtual void | updateSettings ()
virtual void | updateWidgets ()
virtual void | updateWidgetsDefault ()
void | updateButtons ()
void | settingsChangedSlot ()
Protected Slots inherited from KDialogBase
virtual void | slotHelp ()
virtual void | slotDefault ()
virtual void | slotDetails ()
virtual void | slotUser3 ()
virtual void | slotUser2 ()
virtual void | slotUser1 ()
virtual void | slotOk ()
virtual void | slotApply ()
virtual void | slotTry ()
virtual void | slotYes ()
virtual void | slotNo ()
virtual void | slotCancel ()
virtual void | slotClose ()
virtual void | applyPressed ()
void | updateGeometry ()
void | slotDelayedDestruct ()

## Protected Member Functions

virtual bool | hasChanged ()
virtual bool | isDefault ()
Protected Member Functions inherited from KDialogBase
virtual void | keyPressEvent (QKeyEvent *e)
virtual void | hideEvent (QHideEvent *)
virtual void | closeEvent (QCloseEvent *e)
virtual void | virtual_hook (int id, void *data)

## Additional Inherited Members

Public Types inherited from KDialogBase
enum | ButtonCode { Help = 0x00000001, Default = 0x00000002, Ok = 0x00000004, Apply = 0x00000008, Try = 0x00000010, Cancel = 0x00000020, Close = 0x00000040, User1 = 0x00000080, User2 = 0x00000100, User3 = 0x00000200, No = 0x00000080, Yes = 0x00000100, Details = 0x00000400, Filler = 0x40000000, Stretch = 0x80000000, NoDefault }
enum | ActionButtonStyle { ActionStyle0 =0, ActionStyle1, ActionStyle2, ActionStyle3, ActionStyle4, ActionStyleMAX }
enum | DialogType { TreeList = KJanusWidget::TreeList, Tabbed = KJanusWidget::Tabbed, Plain = KJanusWidget::Plain, Swallow = KJanusWidget::Swallow, IconList = KJanusWidget::IconList }
Public Slots inherited from KDialogBase
void | enableButton (ButtonCode id, bool state)
void | enableButtonOK (bool state)
void | enableButtonApply (bool state)
void | enableButtonCancel (bool state)
void | enableLinkedHelp (bool state)
void | delayedDestruct ()
void | setHelpLinkText (const QString &text)
void | setHelp (const QString &anchor, const QString &appname=QString::null)
void | helpClickedSlot (const QString &)
void | setDetails (bool showDetails)
void | setDetailsWidget (QWidget *detailsWidget)
void | updateBackground ()
void | cancel ()
Public Slots inherited from KDialog
virtual void | polish ()
virtual void | setCaption (const QString &caption)
virtual void | setPlainCaption (const QString &caption)

## Detailed Description

Standard KDE configuration dialog class.

The KConfigDialog class provides an easy and uniform means of displaying a settings dialog using KDialogBase, KConfigDialogManager and a KConfigSkeleton derived settings class.

KConfigDialog handles the enabling and disabling of buttons, creation of the dialog, and deletion of the widgets. Because of KConfigDialogManager, this class also manages: restoring the settings, reseting them to the default values, and saving them. This requires that the names of the widgets corresponding to configuration entries have to have the same name plus an additional "kcfg_" prefix. For example the widget named "kcfg_MyOption" would be associated with the configuration entry "MyOption".

Here is an example usage of KConfigDialog:

void KCoolApp::showSettings(){
if(KConfigDialog::showDialog("settings"))
return;
KConfigDialog *dialog = new KConfigDialog(this, "settings", MySettings::self(), KDialogBase::IconList);
dialog->addPage(new General(0, "General"), i18n("General") );
dialog->addPage(new Appearance(0, "Style"), i18n("Appearance") );
connect(dialog, SIGNAL(settingsChanged()), mainWidget, SLOT(loadSettings()));
connect(dialog, SIGNAL(settingsChanged()), this, SLOT(loadSettings()));
dialog->show();
}

Other than the above code, each class that has settings in the dialog should have a loadSettings() type slot to read settings and perform any necessary changes.

Please note that using the setMainWidget method inherited from KDialogBase currently yields broken behaviour at runtime; use addPage() instead.

See also
  KConfigSkeleton

Author
  Waldo Bastian basti.nosp@m.an@k.nosp@m.de.or.nosp@m.g

Since
  3.2

Definition at line 72 of file kconfigdialog.h.

## Constructor & Destructor Documentation

KConfigDialog::KConfigDialog | ( | QWidget * | parent,
|  | const char * | name,
|  | KConfigSkeleton * | config,
|  | DialogType | dialogType = `IconList`,
|  | int | dialogButtons = `Default|Ok|Apply|Cancel|Help`,
|  | ButtonCode | defaultButton = `Ok`,
|  | bool | modal = `false`
| ) |  |

Parameters

  parent | - The parent of this object. Even though the class deletes itself the parent should be set so the dialog can be centered with the application on the screen.
  name | - The name of this object. The name is used in determining if there can be more than one dialog at a time. Use names such as: "Font Settings" or "Color Settings" and not just "Settings" in applications where there is more than one dialog.
  dialogType | - Type used in creating the dialog. See KDialogBase
  config | - Config object containing settings.
  dialogButtons | - Buttons that should show up on the dialog.
  defaultButton | default button that is choosen by hitting the enter key.
  modal | - Whether the dialog should be modal. To prevent more than one non-modal settings dialog from showing the static function showDialog() can be used in determining if the settings dialog already exists before creating a new KConfigDialog object.

Definition at line 49 of file kconfigdialog.cpp.

KConfigDialog::~KConfigDialog | ( |  | ) |

Deconstructor, removes name from the list of open dialogs.

Deletes private class.

See also
  exists()

Definition at line 80 of file kconfigdialog.cpp.

## Member Function Documentation

void KConfigDialog::addPage | ( | QWidget * | page,
|  | const QString & | itemName,
|  | const QString & | pixmapName,
|  | const QString & | header = `QString::null`,
|  | bool | manage = `true`
| ) |  |

Adds page to the dialog and to KConfigDialogManager.

When an application is done adding pages show() should be called to display the dialog. Note that after you call show() you can not add any more pages to the dialog.

Parameters

  page | - Pointer to the page that is to be added to the dialog. This object is reparented.
  itemName | - Name of the page.
  pixmapName | - Name of the pixmap that should be used if needed.
  header | - Header text use in the list modes. Ignored in Tabbed mode. If empty, the itemName text is used when needed.
  manage | - Whether KConfigDialogManager should manage the page or not.

Definition at line 86 of file kconfigdialog.cpp.

void KConfigDialog::addPage | ( | QWidget * | page,
|  | KConfigSkeleton * | config,
|  | const QString & | itemName,
|  | const QString & | pixmapName,
|  | const QString & | header = `QString::null`
| ) |  |

Adds page to the dialog that is managed by a custom KConfigDialogManager.

This is useful for dialogs that contain settings spread over more than one configuration file and thus have/need more than one KConfigSkeleton. When an application is done adding pages show() should be called to display the dialog. Note that after you call show() you can not add any more pages to the dialog.

Parameters

  page | - Pointer to the page that is to be added to the dialog. This object is reparented.
  config | - Config object containing corresponding settings.
  itemName | - Name of the page.
  pixmapName | - Name of the pixmap that should be used if needed.
  header | - Header text use in the list modes. Ignored in Tabbed mode. If empty, the itemName text is used when needed.

Definition at line 97 of file kconfigdialog.cpp.

KConfigDialog * KConfigDialog::exists | ( | const char * | name | ) |

static

See if a dialog with the name 'name' already exists.

See also
  showDialog()

Parameters

  name | - Dialog name to look for.

Returns
  Pointer to widget or NULL if it does not exist.

Definition at line 161 of file kconfigdialog.cpp.

virtual bool KConfigDialog::hasChanged | ( |  | ) |

inline protected virtual

Returns whether the current state of the dialog is different from the current configutation.

Virtual function for custom additions.

Definition at line 233 of file kconfigdialog.h.

virtual bool KConfigDialog::isDefault | ( |  | ) |

inline protected virtual

Returns whether the current state of the dialog is the same as the default configuration.

Definition at line 239 of file kconfigdialog.h.

void KConfigDialog::settingsChanged | ( |  | ) |

signal

One or more of the settings have been permanently changed such as if the user clicked on the Apply or Ok button.

void KConfigDialog::settingsChanged | ( | const char * | dialogName | ) |

signal

One or more of the settings have been permanently changed such as if the user clicked on the Apply or Ok button.

This signal is useful when using KConfigDialog to configure items in a list. When emitted the main class would then know what item in the list was actually changed.

Parameters

  dialogName | the name of the dialog.

void KConfigDialog::settingsChangedSlot | ( |  | ) |

protected slot

Some setting was changed.

Emit the signal with the dialogs name

Definition at line 206 of file kconfigdialog.cpp.

void KConfigDialog::show | ( | void |  | ) |

virtual

Show the dialog.

Definition at line 214 of file kconfigdialog.cpp.

bool KConfigDialog::showDialog | ( | const char * | name | ) |

static

Attempts to show the dialog with the name 'name'.

See also
  exists()

Parameters

  name | - The name of the dialog to show.

Returns
  True if the dialog 'name' exists and was shown.

Definition at line 166 of file kconfigdialog.cpp.

void KConfigDialog::updateButtons | ( |  | ) |

protected slot

Updates the Apply and Default buttons.

Definition at line 174 of file kconfigdialog.cpp.

void KConfigDialog::updateSettings | ( |  | ) |

protected virtual slot

Update the settings from the dialog.

Virtual function for custom additions.

Example use: User clicks Ok or Apply button in a configure dialog.

Definition at line 246 of file kconfigdialog.cpp.

void KConfigDialog::updateWidgets | ( |  | ) |

protected virtual slot

Update the dialog based on the settings.

Virtual function for custom additions.

Example use: Initialisation of dialog. Example use: User clicks Reset button in a configure dialog.

Definition at line 250 of file kconfigdialog.cpp.

void KConfigDialog::updateWidgetsDefault | ( |  | ) |

protected virtual slot

Update the dialog based on the default settings.

Virtual function for custom additions.

Example use: User clicks Defaults button in a configure dialog.

Definition at line 254 of file kconfigdialog.cpp.

void KConfigDialog::widgetModified | ( |  | ) |

signal

A widget in the dialog was modified.

The documentation for this class was generated from the following files:

- kconfigdialog.h
- kconfigdialog.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys